#include <reg52.h>
#include <intrins.h>
//-----------------------Ϯźͱ----------------------------------------------
#define uchar	unsigned char	//궨
#define uint	unsigned int	//궨

/*P2ڵĹܽŶ*/

sbit    SJA_CS  = P2^7; //SJA1000Ƭѡܽţ͵ƽЧ
sbit	SJA_RST = P1^2;

/*P3ڵĹܽŶ*/
sbit	SJA_RD	= P3^7;
sbit	SJA_WR	= P3^6;

//-----------------------ѰַĻַ--------------------------------------------------------
#define base_Adr 0x7F00   
//-----------------------߶ʱĴֵ--------------------------------------------------------
#define SJA_BTR0 0x07                                 //ֵҪûҪĲʽм㣬ƼʹĲʼ
#define SJA_BTR1 0x2F

//-----------------------ýձͣʾ--------------------------------------------------------
                                                      //ֵҪûʵҪ
#define SJA_ACR 0x11                                  //մĴֵ
#define SJA_AMR 0xFF                                 //μĴֵ
//-----------------------ʱ--------------------------------------------------------
                                                      //ֵҪûʵҪ
#define SJA_OCR 0xaa                                  //ƼĴֵ
#define SJA_CDR 0x40                                  //ʱӷƵĴֵ
//-----------------------SJAжϣ1Ϊж--------------------------------------------------------
#define SJA_OIE 0                                    //ж
#define SJA_EIE 0                                    //ж
#define SJA_TIE 0                                    //ж
#define SJA_RIE 1                                    //ж
//-----------------------ַָ룬ַָ--------------------------------------------------------
unsigned char xdata *SJA_base_Adr = base_Adr;
//-----------------------Ӳϱ־λ--------------------------------------------------------
bit bdata    connect_OK=0;                            //connect_OK=1豸
                                                      //connect_OK=0豸ӹ
//-----------------------Ӳϱ־λ--------------------------------------------------------
bit bdata    SJA_workmode=1;                          //SJA_workmode=1SJAڹģʽ
                                                      //SJA_workmode=0ڸλģʽ

//-----------------------SJA1000дݽṹ--------------------------------------------------------
struct BASICCAN_BUFStruct{
			   unsigned char IDH8;
			   unsigned char IDL_R_DLC;
			   unsigned char Frame_Data[8];
			   }receive_BUF,send_BUF;
//------------------------------------------------------------------------------------------------------
//  Ӻ
//  send_BUF_init
// ں 
// ں 
//  MCUڹṹsend_BUFֵ
//------------------------------------------------------------------------------------------------------
bit send_BUF_init(void)
{
	//send_now()ʱ͵ʼġûݾԼ
	bit setting_success=0; 

	send_BUF.IDH8		=	0x99;
	send_BUF.IDL_R_DLC	=	0xE8;                  //IDL_R_DLC4ΪRTRλ=0Զ=1

	send_BUF.Frame_Data[0]	=	0x11;
	send_BUF.Frame_Data[1]	=	0x22;
	send_BUF.Frame_Data[2]	=	0x33;
	send_BUF.Frame_Data[3]	=	0x44;
	send_BUF.Frame_Data[4]	=	0x55;
	send_BUF.Frame_Data[5]	=	0x66;
	send_BUF.Frame_Data[6]	=	0x77;
	send_BUF.Frame_Data[7]	=	0x88;
	
	setting_success = 1;
	return(setting_success);
}
//------------------------------------------------------------------------------------------------------
//  ʱ
//  delay
// ں 
// ں 
//  ʱ
//------------------------------------------------------------------------------------------------------
void delay(unsigned char time)
{
    while(time--);
}
//------------------------------------------------------------------------------------------------------
//  SJA1000
//  CANREG_write
// ں SJAREG_ADRsetting
// ں 
//  дSJA1000ļĴ
//------------------------------------------------------------------------------------------------------
void CANREG_write(unsigned char SJAREG_ADR, unsigned char setting)
{
    *(SJA_base_Adr+SJAREG_ADR)=setting;
}
//------------------------------------------------------------------------------------------------------
//  SJA1000
//  CANREG_read
// ں SJAREG_ADR
// ں SJAREG_data
//  SJA1000ļĴ
//------------------------------------------------------------------------------------------------------
unsigned char CANREG_read(unsigned char SJAREG_ADR)
{
	unsigned char SJAREG_data;
	SJAREG_data=*(SJA_base_Adr+SJAREG_ADR);
	return(SJAREG_data);
}
//------------------------------------------------------------------------------------------------------
//    SJA1000
//    SJAconnect_judge
// ں   
// ں   
// ȫֱ   connect_OK
// Ĵ ԼĴַ09
//    жSJA1000Ƿ
//------------------------------------------------------------------------------------------------------
void SJAconnect_judge(void)
{
   CANREG_write(0x09,0xAA);                //дAAԼĴַ09
   if(CANREG_read(0x09)==0xAA)
    {
     connect_OK=1;                         // 
     }
	else 
	{
	connect_OK=0;                         //ӹ
	}  
}

//------------------------------------------------------------------------------------------------------
//    SJA1000
//    setting_SJA_resetmode
// ں   
// ں   
// ȫֱ   SJA_workmode
// Ĵ ƼĴַ00
//    SJAڸλģʽ
//------------------------------------------------------------------------------------------------------
void setting_SJA_resetmode(void)
{
	unsigned char CONTROL_REGdata;  
	CONTROL_REGdata=CANREG_read(0x00);
	CONTROL_REGdata=CONTROL_REGdata|0x01;
	CANREG_write(0x00,CONTROL_REGdata);
		if((CANREG_read(0x00)&0x01)==1) 
			{
			SJA_workmode=0;                        //øλģʽɹ
			}
		else 
			{
			SJA_workmode=1;                         //øλģʽʧ
			}  
}

//------------------------------------------------------------------------------------------------------
//    SJA1000
//    setting_SJA_workingmode
// ں   
// ں   
// ȫֱ   SJA_workmode
// Ĵ ƼĴַ00
//    SJAģʽ
//------------------------------------------------------------------------------------------------------
void setting_SJA_workingmode(void)
{
	unsigned char CONTROL_REGdata;  
	CONTROL_REGdata=CANREG_read(0x00);
	CONTROL_REGdata=CONTROL_REGdata&0xFE;
	CANREG_write(0x00,CONTROL_REGdata);
		if((CANREG_read(0x00)&0x01)==0) 
			{
			SJA_workmode=1;                        //ùģʽɹ
			}
		else 
			{
			SJA_workmode=0;                         //ùģʽʧ
			}  
}
//------------------------------------------------------------------------------------------------------
//    SJA1000
//    setting_SJA_rate
// ں   SJA_BTR0SJA_BTR1
// ں   setting_success
// Ĵ ߶ʱĴBTR1ַ07BTR0ַ06
//    SJA
// Ҫ   ֻڸλģʽ
//------------------------------------------------------------------------------------------------------
bit setting_SJA_rate(void)
{
	bit setting_success;  
	while(SJA_workmode)
		{
		setting_SJA_resetmode();                   //SJAڸλģʽ
		}
    CANREG_write(0x06,SJA_BTR0);
	CANREG_write(0x07,SJA_BTR1);
    if((CANREG_read(0x06)==SJA_BTR0)&(CANREG_read(0x07)==SJA_BTR1))
	    {
         setting_success=1;                        //óɹ
		}
	else 
		{
		setting_success=0;                         //ʧ
	    }  
	return(setting_success);
}

//------------------------------------------------------------------------------------------------------
//    SJA1000
//    setting_SJA_dataselect
// ں   SJA_ACRSJA_AMR
// ں   setting_success
// Ĵ մĴACRַ04μĴAMRַ05
//    SJA
// Ҫ   ֻڸλģʽ
//------------------------------------------------------------------------------------------------------
bit setting_SJA_dataselect(void)
{
	bit setting_success;  
	while(SJA_workmode)
		{
		setting_SJA_resetmode();                   //SJAڸλģʽ
		}
    CANREG_write(0x04,SJA_ACR);
	CANREG_write(0x05,SJA_AMR);
    if((CANREG_read(0x04)==SJA_ACR)&(CANREG_read(0x05)==SJA_AMR))
	    {
         setting_success=1;                        //˲óɹ
		}
	else 
		{
      	setting_success=0;                         //˲ʧ
	    }  
	return(setting_success);
}

//------------------------------------------------------------------------------------------------------
//    SJA1000
//    setting_SJA_CLK
// ں   SJA_OCRSJA_CDR
// ں   setting_success
// Ĵ ƼĴOCRַ08ʱӷƵĴCDRַ31
//    SJAʼ
// Ҫ   ֻڸλģʽ
//------------------------------------------------------------------------------------------------------
bit setting_SJA_CLK(void)
{
	bit setting_success;  
	while(SJA_workmode)
		{
		setting_SJA_resetmode();                   //SJAڸλģʽ
		}
    CANREG_write(0x08,SJA_OCR);
	CANREG_write(0x1f,SJA_CDR);
    if((CANREG_read(0x08)==SJA_OCR)&(CANREG_read(0x1f)==SJA_CDR))
	    {
         setting_success=1;                        //˲óɹ
		}
	else 
		{
       	setting_success=0;                         //˲ʧ
	    }  
	return(setting_success);
}
//------------------------------------------------------------------------------------------------------
//    SJA1000
//    setting_SJA_interrupt
// ں   SJA_OIE,SJA_EIE,SJA_TIESJA_RIE
// ں   setting_success
// Ĵ ƼĴ00
//    SJAжͺж״̬
// Ҫ   ֻڸλģʽ
//------------------------------------------------------------------------------------------------------
bit setting_SJA_interrupt(void)
{
	bit setting_success;  
	unsigned char CONT_buf,temp=0;
	while(SJA_workmode)
		{
		setting_SJA_resetmode();                   //SJAڸλģʽ
		}
	CONT_buf=CANREG_read(0x00);
	temp=SJA_OIE*16+SJA_EIE*8+SJA_TIE*4+SJA_RIE*2;
	CONT_buf=(temp&0x1E)|(CONT_buf&0x01);
    CANREG_write(0x00,CONT_buf);
    if(CANREG_read(0x00)==CONT_buf|0x20)         //CR.5Ǳλãλֵ߼1
	    {
         setting_success=1;                        //˲óɹ
		}
	else 
		{
       	setting_success=0;                         //˲ʧ
		}  
	return(setting_success);
}
//------------------------------------------------------------------------------------------------------
//    SJA1000
//    write_SJAsendBUF
// ں   
// ں   setting_success
// Ĵ ͻ10-19״̬Ĵ02
//    дͻ
// Ҫ   ֻڹģʽд
//------------------------------------------------------------------------------------------------------
bit write_SJAsendBUF(void)
{
	bit setting_success=0;  
	unsigned char i;
	while(SJA_workmode==0)
		{
		setting_SJA_workingmode();                   //SJAڹģʽ
		}
	if((CANREG_read(0x02)&0x10)==0)
		{
		if((CANREG_read(0x02)&0x04)!=0)
			{
			CANREG_write(0x0a,send_BUF.IDH8);
			CANREG_write(0x0b,send_BUF.IDL_R_DLC);
			}
		for(i=0;i<8;i++)
			{
			CANREG_write(0x0c+i,send_BUF.Frame_Data[i]);
			}
		setting_success=1;                        //ͼĴдɹ
		}
return(setting_success);
}

//------------------------------------------------------------------------------------------------------
//    SJA1000
//    read_SJAsendBUF
// ں   
// ں   setting_success
// Ĵ ջ20-29״̬Ĵ02
//    дͻ
// Ҫ   ֻڹģʽд
//------------------------------------------------------------------------------------------------------
bit read_SJAreceiveBUF(void)
{
	bit setting_success=0;  
	unsigned char i;
	while(SJA_workmode==0)
		{
		setting_SJA_workingmode();                   //SJAڹģʽ
		}
	if((CANREG_read(0x02)&0x01)!=0)
		{
		if((CANREG_read(0x02)&0x10)==0)
			{
			receive_BUF.IDH8=CANREG_read(0x14);
			receive_BUF.IDL_R_DLC=(CANREG_read(0x15));
			for(i=0;i<8;i++)
				{
				receive_BUF.Frame_Data[i]=CANREG_read(0x16+i);
				}
			}
		setting_success=1;                        //ռĴɹ
		}
 	return(setting_success);
}
//------------------------------------------------------------------------------------------------------
//    ӳ
//    SJA1000_init
// ں   
// ں   
// Ĵ  1ƼĴַ00
//             2մĴACRַ04
//             3μĴAMRַ05   
//             4߶ʱĴBTR0ַ06
//             5߶ʱĴBTR1ַ07
//             6ƼĴOCRַ08
//             7ԼĴַ09)
//             8ʱӷƵĴCDRַ31
//	       9жʹܼĴ
//    SJA1000ʼ
// Ҫ   ڸλģʽУʼ빤״̬
//------------------------------------------------------------------------------------------------------
void SJA1000_init(void)
{
	while(connect_OK==0)             
		{
		SJAconnect_judge();             //豸
		}
	while(SJA_workmode)
		{
		setting_SJA_resetmode();         //SJA1000Ϊλģʽ
		}
	while(setting_SJA_rate()==0);		//߲
	while(setting_SJA_dataselect()==0);  //SJAݵĸʽʾλ
	while(setting_SJA_CLK()==0);		//SJAʱӵʽ
	while(setting_SJA_interrupt()==0);  //SJAжʹ
	while(!SJA_workmode)
		{
		setting_SJA_workingmode();       //빤ģʽ
		}
}
//------------------------------------------------------------------------------------------------------
//    жϴ
//    send_interrupt
// ں   
// ں   
// Ĵ 
//    жϴ
//------------------------------------------------------------------------------------------------------
void send_now(void)
{
	unsigned char state;
//	unsigned char CMR_REGdata;  
	do
    {
        state = CANREG_read(0x02);		//SRΪSJA1000״̬Ĵ
    }
    while(( state & 0x10 )|(!(state & 0x08))|(!(state & 0x04)));//ѯSJA1000Ƿڽ״̬״̬߷ͻ

	while(write_SJAsendBUF()==0);                //д뻺
//	CMR_REGdata = CANREG_read(0x01);	//CMRֻдĴɶֵ1111 1111
//	CMR_REGdata	= CMR_REGdata | 0x01;
    CANREG_write(0x01,0x01);			//λλ
}  

//------------------------------------------------------------------------------------------------------
//    жϴ
//    receive_interrupt
// ں   
// ں   
// Ĵ 
//     жϴ
//------------------------------------------------------------------------------------------------------
void receive_now(void)
{
	while(read_SJAreceiveBUF()==0);
	CANREG_write(0x01,0x04);			//CMRд0x04ͷŽջ
}

//------------------------------------------------------------------------------------------------------
//    жϺ
//    SJA_INTR
// ں   
// ں   
// Ĵ жϼĴַ03
//    жϷжʲôжϣӦжϴ
//------------------------------------------------------------------------------------------------------
void SJA_INTR(void) interrupt 0  //CanBusӿоƬж(INTR0)
{
  //˽жϺͷжϣжϣSJA1000⣬IRĸλλֵ1.
  unsigned char sta;

  EA  = 0;							//رж
  EX0 = 0;							//رⲿж
  sta = CANREG_read(0x03);		    //жϼĴIR
  
  if(sta == 0xe2)                  //жϴ
    {
	send_now();
	}
  else if(sta == 0xe1)		             //ж,
	{
	receive_now();
	}  
  else
	MCU_init();
  EX0 = 1;
  EA  = 1;
}

void MCU_init(void)
{
	SJA_RST = 0;
	SJA_CS  = 0;
	delay(5000);
	delay(5000);
	EX0 = 1;
	IT0 = 0;
	EA  = 1;
	SJA_CS = 1;
	SJA_RST = 1;
}

void main()
{
 	MCU_init();
	SJA1000_init();
	while(send_BUF_init()==0);
	while(1)
	{

	}
}
